"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("util");
var mysql_1 = require("mysql");
var config_1 = __importDefault(require("./config"));
var pool = (0, mysql_1.createPool)(config_1.default);
pool.getConnection(function (err, connection) {
    if (err) {
        console.log("\u001B[1m\u001B[31m\n    Connection lost to database ! \u001B[0m\n    -------------------------- \u001B[33m\n        host    : " + (config_1.default === null || config_1.default === void 0 ? void 0 : config_1.default.host) + "         \n        port    : " + (config_1.default === null || config_1.default === void 0 ? void 0 : config_1.default.port) + "        \n        user    : " + config_1.default.user + "           \n        password: " + config_1.default.password + "   \n        database: " + config_1.default.database + " \u001B[0m  \n    --------------------------\n    ");
    }
    if (connection)
        connection.release();
    return;
});
pool.query = (0, util_1.promisify)(pool.query);
exports.default = pool;
