import Base from "./Base";
export declare class Schema extends Base {
    constructor({ debug }?: {
        debug?: boolean | undefined;
    });
    protected timeStamp: Array<string>;
    table: (table: string, objects: any, { timeStamp }?: {
        timeStamp?: boolean | undefined;
    }) => Promise<void>;
}
export declare class Blueprint {
    protected type: string | undefined;
    protected attrbuites: Array<string>;
    private _addType;
    private _addAttrbuite;
    /**
     *
     * types
     *
    */
    int(): this;
    tinyInt(n?: number): this;
    bigInt(n?: number): this;
    double(): this;
    float(): this;
    varchar(n?: number): this;
    char(n?: number): this;
    longText(): this;
    mediumText(): this;
    tinyText(): this;
    text(): this;
    enum(...n: any): this;
    date(): this;
    dateTime(): this;
    timestamp(): this;
    /**
     *
     * attrbuites
     *
    */
    unsigned(): this;
    unique(): this;
    null(): this;
    notNull(): this;
    primary(): this;
    default(n: any): this;
    defaultTimestamp(): this;
    autoIncrement(): this;
}
